Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.ode.nonstiff
Class RungeKuttaIntegrator

    java.lang.Object
      org.apache.commons.math.ode.AbstractIntegrator
          org.apache.commons.math.ode.nonstiff.RungeKuttaIntegrator

All Implemented Interfaces:
  FirstOrderIntegrator, ODEIntegrator

Direct Known Subclasses:
  ClassicalRungeKuttaIntegrator, EulerIntegrator, GillIntegrator, MidpointIntegrator, ThreeEighthesIntegrator

    public abstract class RungeKuttaIntegrator

extends AbstractIntegrator

This class implements the common part of all fixed step Runge-Kutta integrators for Ordinary Differential Equations.

These methods are explicit Runge-Kutta methods, their Butcher arrays are as follows :

        0  |
       c2  | a21
       c3  | a31  a32
       ... |        ...
       cs  | as1  as2  ...  ass-1
           |--------------------------
           |  b1   b2  ...   bs-1  bs

Since:
  1.2
Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 fÃ©vr. 2011) $
See Also:
  `EulerIntegrator`, `ClassicalRungeKuttaIntegrator`, `GillIntegrator`, `MidpointIntegrator`

Field Summary

Fields inherited from class org.apache.commons.math.ode.AbstractIntegrator
`isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

Constructor Summary
`protected` | `RungeKuttaIntegrator(String name, double[] c, double[][] a, double[] b, org.apache.commons.math.ode.nonstiff.RungeKuttaStepInterpolator prototype, double step)` Simple constructor.

Method Summary
`double` | `integrate(FirstOrderDifferentialEquations equations, double t0, double[] y0, double t, double[] y)` Integrate the differential equations up to the given time.

Methods inherited from class org.apache.commons.math.ode.AbstractIntegrator
`acceptStep, addEndTimeChecker, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getCurrentStepStart, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, requiresDenseOutput, resetEvaluations, sanityChecks, setEquations, setMaxEvaluations, setStateInitialized`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RungeKuttaIntegrator

    protected RungeKuttaIntegrator(String name,
                                   double[] c,
                                   double[][] a,
                                   double[] b,
                                   org.apache.commons.math.ode.nonstiff.RungeKuttaStepInterpolator prototype,
                                   double step)

  Simple constructor. Build a Runge-Kutta integrator with the given step. The default step handler does nothing.

  Parameters:
    `name` - name of the method
    `c` - time steps from Butcher array (without the first zero)
    `a` - internal weights from Butcher array (without the first empty row)
    `b` - propagation weights for the high order method from Butcher array
    `prototype` - prototype of the step interpolator to use
    `step` - integration step

Method Detail

### integrate

    public double integrate(FirstOrderDifferentialEquations equations,
                            double t0,
                            double[] y0,
                            double t,
                            double[] y)
                     throws DerivativeException,
                            IntegratorException

  Integrate the differential equations up to the given time.

  This method solves an Initial Value Problem (IVP).

  Since this method stores some internal state variables made available in its public interface during integration (`ODEIntegrator.getCurrentSignedStepsize()`), it is not thread-safe.

  Parameters:
    `equations` - differential equations to integrate
    `t0` - initial time
    `y0` - initial value of the state vector at t0
    `t` - target time for the integration (can be set to a value smaller than `t0` for backward integration)
    `y` - placeholder where to put the state vector at each successful step (and hence at the end of integration), can be the same object as y0
  Returns:
    stop time, will be the same as target time if integration reached its target, but may be different if some `EventHandler` stops it at some point.
  Throws:
    `DerivativeException` - this exception is propagated to the caller if the underlying user function triggers one
    `IntegratorException` - if the integrator cannot perform integration

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2011 The Apache Software Foundation. All Rights Reserved.